/***** INCLUDES *****/
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <math.h>
#include <graphics.h>
#include <C:\NET\SOURCE\geonet.h>  /* structuren */
#include <C:\NET\SOURCE\math_m.c>  /* functionen matrix*/
#include <C:\NET\SOURCE\file.c>    /* functionen file*/
#include <C:\NET\SOURCE\grafic.c>  /* funktionen grafic/*
/***** CONSTANTEN *****/
#define SYNTAX "\nGeoNetP <project>\n        </h> Hilfe\n"
#define HILFE  "\nProgramm zur Darstellung von Lagenetzen\
\n\n[projekt]: Projektname, dieser sollte nur 8 Zeichen enthalten, die den\
\nKonventionen fr Dateinamen entsprechen.\
\nEine Eingabedatei '[project].002' wird im aktuellen Verzeichnis erwartet."
#define RO (M_PI/200)
#define HCOL 0
#define VCOL 63
#define ECOL 4
#define KCOL 1
int main(int argc, char *argv[])
	{
	/***** VARIABLEN *****/
	int a, b, e=0,
		 i,
		 fn, f, n, s, r,
		 g_driver=9, g_mode=2,
		 c=-1, ca=-1,
		 x=1., y=0., tm=10;
	double buf,
			 maxy, maxx, miny, minx,
			 mx, my, mo,
			 m=1., zm=1., zx=0., zy=0.;

	char sbuf[255], pname[13], num[20];
	FILE *in;
	/***** ARGUMENTE ENTGEGENNEHMEN *****/
	if(argc < 2)
		{
		printf(SYNTAX);
		exit (1);
		}
	if(!strcmp(argv[1],"/?"))
		{
		printf(SYNTAX);
		printf(HILFE);
		exit (1);
		}
	if(!projname(argv[1]))
		{
		printf("\nfalscher Projektname\n");
		printf(HILFE);
		exit(1);
		}

	/***** DATEIEN FFNEN *****/
	strncpy(pname, argv[1], 8);
	in   = fileopen(strcat(pname, ".002"), "r");  /*Eingabedatei*/
	strncpy(pname, argv[1], 8);

	/***** DATEN LESEN *****/
	/* Anzahl der Elemente zhlen */
	f=0; n=0; s=0; r=0;
	while(!feof(in))
		{
		fgets(sbuf, 255, in);
		if (sbuf[0] != '*') a=atoi(sbuf); else a=0;
		switch (a)
			{
			case 1: f++; break;
			case 2: n++; break;
			case 3: r++; break;
			case 4: s++; break;
			}
		}
	rewind(in);
	/* Felder dimensionieren */
	p=  malloc((n+f)*sizeof(_p));
	ri= malloc(r*sizeof(_ri));
	st= malloc(s*sizeof(_st));
	ell=malloc(n*sizeof(_ell));
	if(r>s) a=r; else a=s;
	sp_zp=malloc(a*2*sizeof(_sp_zp));
	fp=malloc(f*sizeof(int));
	np=malloc(n*sizeof(int));
	/* Daten einlesen */
	fn=0;n=0;r=0;s=0;
	while (!feof(in))
		{
		fgets(sbuf, 255, in);
		if (sbuf[0] != '*') a=atoi(sbuf); else a=0;
		switch (a)
			{
			case 1: sscanf(sbuf, "%i %li %lf %lf", &p[fn].bed,&p[fn].nr,&p[fn].x[0],&p[fn].x[1]); fn++; break;
			case 2: sscanf(sbuf, "%i %li %lf %lf %lf %lf %lf %lf %lf", &p[fn].bed,&p[fn].nr,&p[fn].x[0],&p[fn].x[1],&buf,&buf,&ell[n].a,&ell[n].b,&ell[n].r); fn++; n++; break;
			case 3: sscanf(sbuf, "%i %li %li %lf %lf", &i,&sp_zp[r*2+0].sp,&sp_zp[r*2+0].zp,&ri[r].r,&ri[r].dr); r++; break;
			case 4: sscanf(sbuf, "%i %li %li %lf %lf", &i,&sp_zp[s*2+1].sp,&sp_zp[s*2+1].zp,&st[s].s,&st[s].ds); s++; break;
			}
		}
	/* Richtungen auf Radiant umrechnen */
	for(i=0; i<r; i++)
		{
		ri[i].r =ri[i].r * RO;
		ri[i].dr=ri[i].dr* RO;
		}
	for(i=0; i<n; i++)
		{
		ell[i].r=ell[i].r * RO;
		}
	/*Beobachtungen indexieren*/
	for(i=0; i<r; i++) beo_ind(i, 0, fn, &ri[i].is, &ri[i].iz);
	for(i=0; i<s; i++) beo_ind(i, 1, fn, &st[i].is, &st[i].iz);
	/*Festpunkte und Neupunkte indexieren*/
	f=0; n=0;
	for(i=0; i<fn; i++)
		{
		if(p[i].bed==1) fp[f++]=i;
		if(p[i].bed==2) np[n++]=i;
		}
	free(sp_zp);
	/***** Grafik *****/
	maxx=pmax(0, fn);
	maxy=pmax(1, fn);
	minx=pmin(0, fn);
	miny=pmin(1, fn);

	initgraph(&g_driver, &g_mode, "");
	hoch =getmaxy();
	breit=getmaxx();

	/* Texte */
	setbkcolor(HCOL);
	setcolor(VCOL);
	strcpy(sbuf,"Projekt: ");
	strcat(sbuf,pname);
	outtextxy(breit/2-breit/6,0, sbuf);
	outtextxy(0,hoch-10,"*/ Ellipsenmastab  +/- Zoomen  e Texte umschalten  r/t/z Texte plazieren  ESC");
	/* Fenster aktivieren */
	setviewport(0,15, breit, hoch-15, 1);
	hoch-=30;
	dx=(maxx-minx);
	dy=(maxy-miny);
	mx=breit/dx;
	my=hoch/dy;
	/*Koordinaten transformieren*/
	if(mx<my) mo=mx; else mo=my;
	mo*=0.9;
	for(i=0; i<fn; i++)
		{
		p[i].x[0]=(p[i].x[0]-minx)*mo;
		p[i].x[1]=(p[i].x[1]-miny)*mo;
		}
	dx*=mo; dy*=mo;
	m=5000.*mo;
	line(   0,     0,     0,hoch);
	line(   0,  hoch, breit,hoch);
	line(breit, hoch, breit,   0);
	line(breit,    0,     0,   0);

	dx/=2.;dy/=2.;breit/=2.;hoch/=2.;

	a=0; b=-1;
	while (c!=27)
		{
		/* Zeichenkoordinaten transformieren */
		if((c=='t')||(c=='T')) {x+=a;y+=b;if(!(x+y)){a=b ;b=0;}if(y==x){b=-a;a=0;}};
		if((c=='r')||(c=='R')) tm-=1;
		if((c=='z')||(c=='Z')) tm+=1;
		if((c=='e')||(c=='E')) e=!e;
		if(c=='+') zm=2.0;
		if(c=='-') zm=0.5;
		if(ca==0)
		  {
		  if(c==77) zx=-10;
		  if(c==75) zx=10;
		  if(c==72) zy=10;
		  if(c==80) zy=-10;
		  }
		for(i=0; i<fn; i++)
			{
			p[i].x[0]=p[i].x[0]*zm+zx;
			p[i].x[1]=p[i].x[1]*zm-zy;
			}
		dx*=zm; dy*=zm;
		zx=0; zy=0; zm=1.;
		clearviewport();
		/* Zentrum */
		setcolor(KCOL);
		line(breit-10, hoch, breit+10, hoch);
		line(breit, hoch-10, breit, hoch+10);
		setcolor(VCOL);
		/* Festpunkte */
		for(i=0; i<f; i++)
			{
			pieslice(tx(p[fp[i]].x[0]),ty(p[fp[i]].x[1]), 0,360,5);
			ltoa(p[fp[i]].nr,num, 10);
			if(!e) outtextxy(tx(p[fp[i]].x[0])+x*tm-(1-x)*textwidth(num)/2,ty(p[fp[i]].x[1])-y*tm-textheight(num)/2,num);
			}
		/* Neupunkte */
		for(i=0; i<n; i++)
			{
			circle(tx(p[np[i]].x[0]),ty(p[np[i]].x[1]),5);
			ltoa(p[np[i]].nr,num, 10);
			if(!e) outtextxy(tx(p[np[i]].x[0])+x*tm-(1-x)*textwidth(num)/2,ty(p[np[i]].x[1])-y*tm-textheight(num)/2,num);
			}
		/* Strecken */
		for(i=0; i<s; i++)
			strecked(tx(p[st[i].is].x[0]),ty(p[st[i].is].x[1]),tx(p[st[i].iz].x[0]),ty(p[st[i].iz].x[1]));
		/* Richtungen */
		for(i=0; i<r; i++)
			richtungd(tx(p[ri[i].is].x[0]),ty(p[ri[i].is].x[1]),tx(p[ri[i].iz].x[0]),ty(p[ri[i].iz].x[1]));
		/* Ellipsen */
		if(c=='*') m*=2.;
		if(c=='/') m/=2.;
		for(i=0; i<n; i++)
			{
			ellipsed(tx(p[np[i]].x[0]),ty(p[np[i]].x[1]), m*ell[i].a, m*ell[i].b, ell[i].r, ECOL);
			if(e)
				{
				setcolor(ECOL);
				sprintf(num,"%i/%imm",(int)(ell[i].a*1000.),(int)(ell[i].b*1000.));
				outtextxy(tx(p[np[i]].x[0])+x*tm-(1-x)*textwidth(num)/2,ty(p[np[i]].x[1])-y*tm-textheight(num)/2,num);
				setcolor(VCOL);
				}
			}
		c=getch();
		if(!c) {ca=c; c=getch();}
		}
	closegraph();
	return 0;
	}
