/* Funktionen fr "stat1_1.c" (bung Statistische Testverfahren /
	Ausgleichsrechnung II */
/* Datenaufbereitung und Matrix-Operationen */

double squ(double x)
	/* liefert x^2 */
	{
	return(x*x);
	}
double str(int s, int z)
	/* liefert die Strecke zw. s und z */
	{
	return(sqrt(squ(p[s].x[0]-p[z].x[0])+squ(p[s].x[1]-p[z].x[1])));
	}
double rich(int s, int z)
	/* liefert die Richtung zw. s und z */
	{
	double r;
	r=atan2(p[z].x[0]-p[s].x[0], p[z].x[1]-p[s].x[1]);
	if (r<0.) r+=2.*M_PI;
	return(r);
	}
void beo_ind(int i, int j, int n, int *is, int *iz)
	/* Vergleicht die Punktnummern der Beobachtungen mit den Punkten
		und trgt diese in den Beobachtungsindex ein */
	{
	int k;
	for(k=0; k<n; k++)
		{
		if(sp_zp[i*2+j].sp==p[k].nr) *is=k;
		if(sp_zp[i*2+j].zp==p[k].nr) *iz=k;
		}
	}
int ori_ind(int n)
	/* Zhlt in den Richtungsstzen die Standpunktnummern
		und setzt Index auf Richtung */
	{
	int i, j=0; long int a=0;
	for(i=0; i<n; i++)
		if(p[ri[i].is].nr != a)
			{
			ori[j].ir=i;
			a=p[ri[i].is].nr;
			j++;
			}
	return(j);
	}
double ds_dx(int s, int z, int pk, int l)
	/* liefert den Ausdruck ds/dx bzw ds/dy */
	{
	if(np[pk]==s)      return((p[s].x[l]-p[z].x[l])/str(s,z));
	else if(np[pk]==z) return((p[z].x[l]-p[s].x[l])/str(s,z));
	else return(0.);
	}
double dr_dx(int s, int z, int pk, int l)
	/* liefert den Ausdruck dr/dx bzw dr/dy */
	{
	double a;
	if(np[pk]==s)      a=(p[s].x[!l]-p[z].x[!l])/squ(str(s,z));
	else if(np[pk]==z) a=(p[z].x[!l]-p[s].x[!l])/squ(str(s,z));
	else a=0.;
	if(l) a*=-1.;
	return(a);
	}
double dr_do(int s, int pk)
	/* liefert den Ausdruck dr/do */
	{
	if(pk==s)		 return(-1);
	else return(0);
	}
double squV(double *V, int z)
	/* liefert V^2 */
	{
	double s=0.; int i;
	for(i=0; i<z; i++)
		s+=V[i]*V[i];
	return(s);
	}
void AtB(double *A, double *B, double *C, int zA, int sA, int sB)
	/* Multiplikation C = A transponiert * B */
	{
	int i,j,k;
	for(j=0; j<sA; j++)
		for(k=0; k<sB; k++)
			{
			C[j*sB+k]=0.;
			for(i=0; i<zA; i++)
				C[j*sB+k]+=A[i*sA+j]*B[i*sB+k];
			}
	}
void AB(double *A, double *B, double *C, int zA, int sA, int sB)
	/* Multiplikation C = A * B */
	{
	int i,j,k;
	for(j=0; j<zA; j++)
		for(k=0; k<sB; k++)
			{
			C[j*sB+k]=0.;
			for(i=0; i<sA; i++)
				C[j*sB+k]+=A[j*sA+i]*B[i*sB+k];
			}
	}
void ABt(double *A, double *B, double *C, int zA, int sA, int zB)
	/* C = A * B(transponiert) */
	{
	int i, j, k;
	for(i=0; i<zA; i++)
		for(j=0; j<zB; j++)
			{
			C[i*zB+j]=0.;
			for(k=0; k<sA; k++)
				C[i*zB+j]+=A[i*sA+k]*B[j*sA+k];
			}
	}
void AmB(double *A, double *B, double *C, int zA, int sA)
	/* C = A - B */
	{
	int i, j;
	for(i=0; i<zA; i++)
		for(j=0; j<sA; j++)
			C[i*sA+j]=A[i*sA+j]-B[i*sA+j];
	}
void aB(double a, double *B, double *C, int zB, int sB)
	/* C = a * B */
	{
	int i, j;
	for(i=0; i<zB; i++)
		for(j=0; j<sB; j++)
			C[i*sB+j]=a*B[i*sB+j];
	}
void inv(double *A, int n)
	/* invertiert die symetrische Matrix A */
	{
	double s,t; int i, j, k;
	for(i=n-1; i>-1; i--)
		for(j=0; j<i; j++)
			A[i*n+j]=0.;
	for(k=0; k<n; k++)
		{
		t = A[k*n+k];
		A[k*n+k] = 1.;
		for(i=k+1; i<n; i++)
			{
			s = A[k*n+i] / t;
			for(j=0; j<n; j++)
				{
				if(j>k && j<i);
				else A[i*n+j] -= s*A[k*n+j];
				}
			}
		A[k*n+k] = t;
		}
	for(i=n-1; i>-1; i--)
		{
		t = A[i*n+i];
		A[i*n+i] = 1.;
		for(k=0; k<i+1; k++)
			{
			s = A[i*n+k];
			for(j=i+1; j<n; j++)
				s -= A[i*n+j] * A[j*n+k];
			A[i*n+k] = s / t;
			}
		for(k=i+1; k<n; k++)
			A[i*n+k] = A[k*n+i];
		}
	}
void AgB(double *A, double *B, int zA, int sA)
	/* A << B */
	{
	int i, j;
	for(i=0; i<zA; i++)
		for(j=0; j<zA; j++)
			A[i*sA+j]=B[i*sA+j];
	}
double spur(double *A, int zA)
	/* liefert die Spur der Matrix A */
	{
	double a=0.; int i;
	for(i=0; i<zA; i++)
		a+=A[i*zA+i];
	return(a);
	}
void mprintf(FILE *stream, char *string, double *A, int z, int s)
	/*schreibt die Matrix A in stream*/
	{
	int i, j;
	fprintf(stream,"%s\n", string);
	for(i=0; i<z; i++)
		{
		for(j=0; j<s; j++)
			fprintf(stream, "%20.10f ", A[i*s+j]);
		fprintf(stream, "\n");
		}
	}