/* Funktionen fr "stat1_1.c" (bung Statistische Testverfahren /
	Ausgleichsrechnung II */
/* Datenaufbereitung und Matrix-Operationen */

double squ(double x)
	/* liefert x^2 */
	{
	return(x*x);
	}
double str(int s, int z)
	/* liefert die Strecke zw. s und z */
	{
	return(sqrt(squ(p[s].x[0]-p[z].x[0])+squ(p[s].x[1]-p[z].x[1])));
	}
double rich(int s, int z)
	/* liefert die Richtung zw. s und z */
	{
	double r;
	r=atan2(p[z].x[0]-p[s].x[0], p[z].x[1]-p[s].x[1]);
	if (r<0.) r+=2.*M_PI;
	return(r);
	}
void beo_ind(int i, int j, int n, int *is, int *iz)
	/* Vergleicht die Punktnummern der Beobachtungen mit den Punkten
		und trgt diese in den Beobachtungsindex ein */
	{
	int k;
	for(k=0; k<n; k++)
		{
		if(sp_zp[i*2+j].sp==p[k].nr) *is=k;
		if(sp_zp[i*2+j].zp==p[k].nr) *iz=k;
		}
	}
int ori_ind(int n)
	/* Zhlt in den Richtungsstzen die Standpunktnummern
		und setzt Index auf Richtung */
	{
	int i, j=0; long int a=0;
	for(i=0; i<n; i++)
		if(p[ri[i].is].nr != a)
			{
			ori[j].ir=i;
			a=p[ri[i].is].nr;
			j++;
			}
	return(j);
	}
double ds_dx(int s, int z, int pk, int l)
	/* liefert den Ausdruck ds/dx bzw ds/dy */
	{
	if(np[pk]==s)      return((p[s].x[l]-p[z].x[l])/str(s,z));
	else if(np[pk]==z) return((p[z].x[l]-p[s].x[l])/str(s,z));
	else return(0.);
	}
double dr_dx(int s, int z, int pk, int l)
	/* liefert den Ausdruck dr/dx bzw dr/dy */
	{
	double a;
	if(np[pk]==s)      a=(p[s].x[!l]-p[z].x[!l])/squ(str(s,z));
	else if(np[pk]==z) a=(p[z].x[!l]-p[s].x[!l])/squ(str(s,z));
	else a=0.;
	if(l) a*=-1.;
	return(a);
	}
double dr_do(int s, int pk)
	/* liefert den Ausdruck dr/do */
	{
	if(pk==s)		 return(-1);
	else return(0);
	}
double squV(double *V, int z)
	/* liefert V^2 */
	{
	double s=0.; int i;
	for(i=0; i<z; i++)
		s+=V[i]*V[i];
	return(s);
	}
void AB(double *A, double *B, double *C, int zA, int sA, int sB)
	/* Multiplikation C = A * B */
	{
	int i,j,k;
	for(j=0; j<zA; j++)
		for(k=0; k<sB; k++)
			{
			C[j*sB+k]=0.;
			for(i=0; i<sA; i++)
				C[j*sB+k]+=A[j*sA+i]*B[i*sB+k];
			}
	}
void inv(double *A, int n)
	/* invertiert die symetrische Matrix A */
	{
	double s,t; int i, j, k;
	for(i=n-1; i>-1; i--)
		for(j=0; j<i; j++)
			A[i*n+j]=0.;
	for(k=0; k<n; k++)
		{
		t = A[k*n+k];
		A[k*n+k] = 1.;
		for(i=k+1; i<n; i++)
			{
			s = A[k*n+i] / t;
			for(j=0; j<n; j++)
				{
				if(j>k && j<i);
				else A[i*n+j] -= s*A[k*n+j];
				}
			}
		A[k*n+k] = t;
		}
	for(i=n-1; i>-1; i--)
		{
		t = A[i*n+i];
		A[i*n+i] = 1.;
		for(k=0; k<i+1; k++)
			{
			s = A[i*n+k];
			for(j=i+1; j<n; j++)
				s -= A[i*n+j] * A[j*n+k];
			A[i*n+k] = s / t;
			}
		for(k=i+1; k<n; k++)
			A[i*n+k] = A[k*n+i];
		}
	}
void AtPA(double *A, double *P, double *N, int b, int n)
	{
	int i, j, k;
	for(i=0; i<n; i++)
		for(j=0; j<n; j++)
			N[i*n+j]=0.;
	for(i=0; i<n; i++)
		for(j=0; j<n; j++)
			for(k=0; k<b; k++)
				N[i*n+j]+=A[k*n+i]*P[k]*A[k*n+j];
	}
void AtPL( double *A, double *P, double *L, double *B, int b, int n)
	{
	int i, j;
	for(j=0; j<n; j++)
		{
		B[j]=0.;
		for(i=0; i<b; i++)
			B[j]+=A[i*n+j]*P[i]*L[i];
		}
	}
void AXmL(double *A, double *X, double *L, double *V, int b, int n)
	{
	int i, j;
	for(i=0; i<b; i++)
		{
		V[i]=0.;
		for(j=0; j<n; j++)
			V[i]+=A[i*n+j]*X[j];
		V[i]-=L[i];
		}
	}
double AtPV( double *A, double *P, double *V, int b, int n)
	{
	int i, j; double a, c=0.;
	for(j=0; j<n; j++)
		{
		a=0.;
		for(i=0; i<b; i++)
			a+=A[i*n+j]*P[i]*V[i];
		c+=a*a;
		}
	return (c);
	}
double VtPV(double *V, double *P, int b)
	{
	int i; double a=0.;
	for(i=0; i<b; i++)
		a+=V[i]*P[i]*V[i];
	return (a);
	}
double spurPQvv (double *A, double *Qxx, double *P, double *R, int b, int n)
	/* erstellt die Diagonalelemente von (P*Qvv) und gibt deren Summe zurck */
	{
	int i, j, k; double a, c=0.;
	for(i=0; i<b; i++)
		{
		R[i]=0.;
		for(j=0; j<n; j++)
			{
			a=0.;
			for(k=0; k<n; k++)
				a+=A[i*n+k]*Qxx[j*n+k];
			R[i]+=a*A[i*n+j];
			}
		R[i]=1.-P[i]*R[i];
		c+=R[i];
		}
	return (c);
	}